[OE-core] [PATCH] systemd-udev: Add systemd-mount to mount.sh

Hongzhi.Song hongzhi.song at windriver.com
Tue Mar 6 02:19:02 UTC 2018


If linux uses systemd as init, systemd-udevd.service sets MountFlags=slave,
which is essentially a sandboxing setting: it detaches mount() operations
done within the service from the rest of the system. This means that,
outside of namespace of systemd-udev, we can not access device mounted by
udev and some operation may not be possible (e.g. mkfs.ext4 /dev/sda1).

This patch adds systemd-mount in /etc/udev/script/mount.sh. The tool
recommended by systemd upstream generally is the best way in particular in
embedded applications to deal with hotpluggable media. Systemd-mount request
the mount operation to be executed by PID 1, and hence outside of the mount
context of udev.

Signed-off-by: Hongzhi.Song <hongzhi.song at windriver.com>
---
 meta/recipes-core/udev/udev-extraconf/mount.sh | 61 +++++++++++++++++++++++---
 1 file changed, 56 insertions(+), 5 deletions(-)

diff --git a/meta/recipes-core/udev/udev-extraconf/mount.sh b/meta/recipes-core/udev/udev-extraconf/mount.sh
index d760328..2fa2925 100644
--- a/meta/recipes-core/udev/udev-extraconf/mount.sh
+++ b/meta/recipes-core/udev/udev-extraconf/mount.sh
@@ -5,9 +5,28 @@
 # Attempt to mount any added block devices and umount any removed devices
 
 
-MOUNT="/bin/mount"
+BASE_INIT="`readlink "/sbin/init"`"
+INIT_SYSTEMD="/lib/systemd/systemd"
+
+if [ "x$BASE_INIT" = "x$INIT_SYSTEMD" ];then
+	# systemd as init uses systemd-mount to mount block devices
+        MOUNT="/usr/bin/systemd-mount"
+        UMOUNT="/usr/bin/systemd-umount"
+
+        if [ -x $MOUNT ] && [ -x $UMOUNT ];
+        then
+                logger "Using systemd-mount to finish mount"
+        else
+                logger "Linux init is using systemd, so please install systemd-mount to finish mount"
+		exit 1
+        fi
+else
+        MOUNT="/bin/mount"
+        UMOUNT="/bin/umount"
+fi
+
 PMOUNT="/usr/bin/pmount"
-UMOUNT="/bin/umount"
+
 for line in `grep -h -v ^# /etc/udev/mount.blacklist /etc/udev/mount.blacklist.d/*`
 do
 	if [ ` expr match "$DEVNAME" "$line" ` -gt 0 ];
@@ -17,6 +36,34 @@ do
 	fi
 done
 
+automount_systemd() {
+        name="`basename "$DEVNAME"`"
+
+        ! test -d "/run/media/$name" && mkdir -p "/run/media/$name"
+        
+        MOUNT="$MOUNT -o silent"
+        
+        # If filesystemtype is vfat, change the ownership group to 'disk', and
+        # grant it with  w/r/x permissions.
+        case $ID_FS_TYPE in
+        vfat|fat)
+                MOUNT="$MOUNT -o umask=007,gid=`awk -F':' '/^disk/{print $3}' /etc/group`"
+                ;;
+        # TODO
+        *)
+                ;;
+        esac
+
+        if ! $MOUNT --no-block -t auto $DEVNAME "/run/media/$name"
+        then
+                #logger "mount.sh/automount" "$MOUNT -t auto $DEVNAME \"/run/media/$name\" failed!"
+                rm_dir "/run/media/$name"
+        else
+                logger "mount.sh/automount" "Auto-mount of [/run/media/$name] successful"
+                touch "/tmp/.automount-$name"
+        fi
+}
+
 automount() {	
 	name="`basename "$DEVNAME"`"
 
@@ -72,9 +119,13 @@ if [ "$ACTION" = "add" ] && [ -n "$DEVNAME" ] && [ -n "$ID_FS_TYPE" -o "$media_t
 	# If the device isn't mounted at this point, it isn't
 	# configured in fstab (note the root filesystem can show up as
 	# /dev/root in /proc/mounts, so check the device number too)
-	if expr $MAJOR "*" 256 + $MINOR != `stat -c %d /`; then
-		grep -q "^$DEVNAME " /proc/mounts || automount
-	fi
+        if expr $MAJOR "*" 256 + $MINOR != `stat -c %d /`; then
+                if [ "`basename $MOUNT`" = "systemd-mount" ];then
+                        grep -q "^$DEVNAME " /proc/mounts || automount_systemd
+                else
+                        grep -q "^$DEVNAME " /proc/mounts || automount
+                fi
+        fi
 fi
 
 
-- 
2.8.1




More information about the Openembedded-core mailing list